unit UContextMenu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvCustomControl, AdvWebBrowser,
  Vcl.Menus;

type
  TMyContextMenuBridge = class(TInterfacedPersistent, IAdvCustomWebBrowserBridge)
  private
    function GetObjectMessage: string;
    procedure SetObjectMessage(const Value: string);
  published
    property ObjectMessage: string read GetObjectMessage write SetObjectMessage;
  end;

  TForm29 = class(TForm)
    AdvWebBrowser1: TAdvWebBrowser;
    PopupMenu1: TPopupMenu;
    Item11: TMenuItem;
    Item12: TMenuItem;
    Item31: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure AdvWebBrowser1DocumentComplete(Sender: TObject);
  private
    FScriptLoaded: Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form29: TForm29;

implementation

{$R *.dfm}

uses
  AdvUtils;

const
  MyContextMenuBridgeName = 'MyContextMenuBridge';

procedure TForm29.AdvWebBrowser1DocumentComplete(Sender: TObject);
const
  LB = #13#10;
var
  s: string;
begin
  if FScriptLoaded then
    Exit;

  s := AdvWebBrowser1.GetBridgeCommunicationLayer(MyContextMenuBridgeName);
  s := s + 'function customContextMenu() {' + LB +
       '  document.addEventListener("contextmenu", function(e) {' + LB +
       '    send' + MyContextMenuBridgeName + 'ObjectMessage(e.clientX + ":" + e.clientY)' + LB +
       '  });' + LB +
       '} customContextMenu();';

  AdvWebBrowser1.ExecuteJavascript(s);

  FScriptLoaded := True;
end;

procedure TForm29.FormCreate(Sender: TObject);
var
  o: TMyContextMenuBridge;
begin
  FScriptLoaded := False;
  AdvWebBrowser1.EnableContextMenu := False;
  o := TMyContextMenuBridge.Create;
  AdvWebBrowser1.AddBridge(MyContextMenuBridgeName, o);
  AdvWebBrowser1.StartDocumentReadyStateThread;
end;

{ TMyContextMenuBridge }

function TMyContextMenuBridge.GetObjectMessage: string;
begin

end;

procedure TMyContextMenuBridge.SetObjectMessage(const Value: string);
var
  p: TPoint;
  x, y: Integer;
  xs, ys: string;
  sc: Single;
begin
  x := 0;
  y := 0;
  xs := Copy(Value, 1, Pos(':', Value) - 1);
  ys := Copy(Value, Pos(':', Value) + 1, Length(Value) - Pos(':', Value));
  if TryStrToInt(xs, x) and TryStrToInt(ys, y) then
  begin
    sc := Form29.CurrentPPI / 96;
    x := Round(x * sc);
    y := Round(y * sc);
    p := Form29.AdvWebBrowser1.ClientToScreen(Point(x, y));
    Form29.PopupMenu1.Popup(p.X, p.Y);
  end;
end;

end.
